Index: molecuilder/src/unittests/CountBondsUnitTest.cpp
===================================================================
--- molecuilder/src/unittests/CountBondsUnitTest.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/CountBondsUnitTest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -16,4 +16,6 @@
 #include <stdio.h>
 #include <cstring>
+
+#include "Helpers/Assert.hpp"
 
 #include "analysis_bonds.hpp"
@@ -40,43 +42,26 @@
 {
   atom *Walker = NULL;
-  BG = NULL;
-  filename = NULL;
-
-  // init private all pointers to zero
-  molecules = NULL;
-  TestMolecule1 = NULL;
-  TestMolecule2 = NULL;
-  hydrogen = NULL;
-  oxygen = NULL;
-  tafel = NULL;
 
   // construct element
-  hydrogen = new element;
-  hydrogen->Z = 1;
-  hydrogen->CovalentRadius = 0.23;
-  strcpy(hydrogen->name, "hydrogen");
-  strcpy(hydrogen->symbol, "H");
-  oxygen = new element;
-  oxygen->Z = 8;
-  oxygen->CovalentRadius = 0.68;
-  strcpy(oxygen->name, "oxygen");
-  strcpy(oxygen->symbol, "O");
-
-  // construct periodentafel
-  tafel = World::getInstance().getPeriode();
-  tafel->AddElement(hydrogen);
-  tafel->AddElement(oxygen);
+  hydrogen = World::getInstance().getPeriode()->FindElement(1);
+  oxygen = World::getInstance().getPeriode()->FindElement(8);
+  CPPUNIT_ASSERT(hydrogen != NULL && "could not find element hydrogen");
+  CPPUNIT_ASSERT(oxygen != NULL && "could not find element oxygen");
 
   // construct molecule (water molecule)
   TestMolecule1 = World::getInstance().createMolecule();
-  Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(TestMolecule1 != NULL && "could not create first molecule");
+  Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = hydrogen;
   *Walker->node = Vector(-0.2418, 0.9350, 0. );
   TestMolecule1->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = hydrogen;
   *Walker->node = Vector(0.9658, 0., 0. );
   TestMolecule1->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = oxygen;
   *Walker->node = Vector(0., 0., 0. );
@@ -84,13 +69,17 @@
 
   TestMolecule2 = World::getInstance().createMolecule();
-  Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(TestMolecule2 != NULL && "could not create second molecule");
+  Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = hydrogen;
   *Walker->node = Vector(-0.2418, 0.9350, 0. );
   TestMolecule2->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = hydrogen;
   *Walker->node = Vector(0.9658, 0., 0. );
   TestMolecule2->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = oxygen;
   *Walker->node = Vector(0., 0., 0. );
@@ -98,4 +87,5 @@
 
   molecules = World::getInstance().getMolecules();
+  CPPUNIT_ASSERT(molecules != NULL && "could not obtain list of molecules");
   molecules->insert(TestMolecule1);
   molecules->insert(TestMolecule2);
@@ -111,4 +101,5 @@
   // create a small file with table
   BG = new BondGraph(true);
+  CPPUNIT_ASSERT(BG != NULL && "could not create BondGraph");
 
   // construct bond graphs
@@ -158,4 +149,5 @@
 {
   double *mirror = new double[3];
+  CPPUNIT_ASSERT(mirror != NULL && "could not create array of doubles");
   for (int i=0;i<3;i++)
     mirror[i] = -1.;
Index: molecuilder/src/unittests/CountBondsUnitTest.hpp
===================================================================
--- molecuilder/src/unittests/CountBondsUnitTest.hpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/CountBondsUnitTest.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -39,7 +39,6 @@
       molecule *TestMolecule1;
       molecule *TestMolecule2;
-      element *hydrogen;
-      element *oxygen;
-      periodentafel *tafel;
+      const element *hydrogen;
+      const element *oxygen;
 
       BondGraph *BG;
Index: molecuilder/src/unittests/LinkedCellUnitTest.cpp
===================================================================
--- molecuilder/src/unittests/LinkedCellUnitTest.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/LinkedCellUnitTest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -38,26 +38,16 @@
   atom *Walker = NULL;
 
-  // init private all pointers to zero
-  TestMolecule = NULL;
-  hydrogen = NULL;
-  tafel = NULL;
-
   // construct element
-  hydrogen = new element;
-  hydrogen->Z = 1;
-  hydrogen->CovalentRadius = 0.23;
-  strcpy(hydrogen->name, "hydrogen");
-  strcpy(hydrogen->symbol, "H");
-
-  // construct periodentafel
-  tafel = World::getInstance().getPeriode();
-  tafel->AddElement(hydrogen);
+  hydrogen = World::getInstance().getPeriode()->FindElement(1);
+  CPPUNIT_ASSERT(hydrogen != NULL && "could not find element hydrogen");
 
   // construct molecule (water molecule)
   TestMolecule = World::getInstance().createMolecule();
+  CPPUNIT_ASSERT(TestMolecule != NULL && "could not create molecule");
   for (double x=0.5;x<3;x+=1.)
     for (double y=0.5;y<3;y+=1.)
       for (double z=0.5;z<3;z+=1.) {
         Walker = World::getInstance().createAtom();
+        CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
         Walker->type = hydrogen;
         *Walker->node = Vector(x, y, z );
@@ -67,4 +57,5 @@
   // construct linked cell
   LC = new LinkedCell (TestMolecule, 1.);
+  CPPUNIT_ASSERT(LC != NULL && "could not create LinkedCell");
 
   // check that TestMolecule was correctly constructed
@@ -205,6 +196,5 @@
   // check internal vectors, returns false, because this atom is not in LC-list!
   Walker = World::getInstance().createAtom();
-  Walker->Name = Malloc<char>(6, "LinkedCellTest::SetIndexToNodeTest - Walker");
-  strcpy(Walker->Name, "test");
+  Walker->setName("test");
   Walker->x= Vector(1,1,1);
   CPPUNIT_ASSERT_EQUAL( false, LC->SetIndexToNode(Walker) );
@@ -213,6 +203,5 @@
   // check out of bounds vectors
   Walker = World::getInstance().createAtom();
-  Walker->Name = Malloc<char>(6, "LinkedCellTest::SetIndexToNodeTest - Walker");
-  strcpy(Walker->Name, "test");
+  Walker->setName("test");
   Walker->x = Vector(0,-1,0);
   CPPUNIT_ASSERT_EQUAL( false, LC->SetIndexToNode(Walker) );
Index: molecuilder/src/unittests/LinkedCellUnitTest.hpp
===================================================================
--- molecuilder/src/unittests/LinkedCellUnitTest.hpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/LinkedCellUnitTest.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -48,6 +48,5 @@
 
       molecule *TestMolecule;
-      element *hydrogen;
-      periodentafel *tafel;
+      const element *hydrogen;
       LinkedCell *LC;
 };
Index: molecuilder/src/unittests/Makefile.am
===================================================================
--- molecuilder/src/unittests/Makefile.am	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/Makefile.am	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -33,7 +33,8 @@
   MemoryAllocatorUnitTest \
   MoleculeDescriptorTest \
-  PlaneUnittest \
   ObserverTest \
   ParserUnitTest \
+  periodentafelTest \
+  PlaneUnittest \
   SingletonTest \
   StackClassUnitTest \
@@ -75,7 +76,8 @@
   memoryusageobserverunittest.cpp \
   MoleculeDescriptorTest.cpp \
-  PlaneUnittest.cpp \
   ObserverTest.cpp \
   ParserUnitTest.cpp \
+  periodentafelTest.cpp \
+  PlaneUnittest.cpp \
   SingletonTest.cpp \
   stackclassunittest.cpp \
@@ -109,4 +111,5 @@
   memoryusageobserverunittest.hpp \
   MoleculeDescriptorTest.hpp \
+  periodentafelTest.hpp \
   PlaneUnittest.hpp \
   ObserverTest.hpp \
@@ -194,4 +197,7 @@
 ParserUnitTest_LDADD = ${ALLLIBS}
 
+periodentafelTest_SOURCES = UnitTestMain.cpp periodentafelTest.cpp periodentafelTest.hpp
+periodentafelTest_LDADD = ${ALLLIBS}
+
 PlaneUnittest_SOURCES = UnitTestMain.cpp PlaneUnittest.cpp PlaneUnittest.hpp
 PlaneUnittest_LDADD = ${ALLLIBS}
Index: molecuilder/src/unittests/ParserUnitTest.cpp
===================================================================
--- molecuilder/src/unittests/ParserUnitTest.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/ParserUnitTest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -31,13 +31,5 @@
 
 void ParserUnitTest::setUp() {
-  element* oxygen = new element();
-  oxygen->symbol[0] = 'O';
-  oxygen->Z = 8;
-  World::getInstance().getPeriode()->AddElement(oxygen);
-
-  element* hydrogen = new element();
-  hydrogen->symbol[0] = 'H';
-  hydrogen->Z = 1;
-  World::getInstance().getPeriode()->AddElement(hydrogen);
+  World::getInstance();
 }
 
Index: molecuilder/src/unittests/analysisbondsunittest.cpp
===================================================================
--- molecuilder/src/unittests/analysisbondsunittest.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/analysisbondsunittest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -40,48 +40,35 @@
   atom *Walker = NULL;
 
-  // init private all pointers to zero
-  TestMolecule = NULL;
-  hydrogen = NULL;
-  tafel = NULL;
-
-  // construct element
-  hydrogen = new element;
-  hydrogen->Z = 1;
-  hydrogen->Valence = 1;
-  hydrogen->NoValenceOrbitals = 1;
-  strcpy(hydrogen->name, "hydrogen");
-  strcpy(hydrogen->symbol, "H");
-  carbon = new element;
-  carbon->Z = 2;
-  carbon->Valence = 4;
-  carbon->NoValenceOrbitals = 4;
-  strcpy(carbon->name, "carbon");
-  strcpy(carbon->symbol, "C");
-
-
-  // construct periodentafel
-  tafel = World::getInstance().getPeriode();
-  tafel->AddElement(hydrogen);
-  tafel->AddElement(carbon);
+  // get elements
+  hydrogen = World::getInstance().getPeriode()->FindElement(1);
+  carbon = World::getInstance().getPeriode()->FindElement(6);
+  CPPUNIT_ASSERT(hydrogen != NULL && "could not find element hydrogen");
+  CPPUNIT_ASSERT(carbon != NULL && "could not find element carbon");
 
   // construct molecule (tetraeder of hydrogens)
   TestMolecule = World::getInstance().createMolecule();
+  CPPUNIT_ASSERT(TestMolecule != NULL && "could not create molecule");
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = hydrogen;
   *Walker->node = Vector(1.5, 0., 1.5 );
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = hydrogen;
   *Walker->node = Vector(0., 1.5, 1.5 );
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = hydrogen;
   *Walker->node = Vector(1.5, 1.5, 0. );
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = hydrogen;
   *Walker->node = Vector(0., 0., 0. );
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = carbon;
   *Walker->node = Vector(0.5, 0.5, 0.5 );
@@ -93,15 +80,21 @@
   // create a small file with table
   filename = new string("test.dat");
+  CPPUNIT_ASSERT(filename != NULL && "could not create string");
   ofstream test(filename->c_str());
-  test << ".\tH\tC\n";
-  test << "H\t1.\t1.2\n";
-  test << "C\t1.2\t1.5\n";
+  test << ".\tH\tHe\tLi\tBe\tB\tC\n";
+  test << "H\t1.\t1.\t1.\t1.\t1.\t1.2\n";
+  test << "He\t1.\t1.\t1.\t1.\t1.\t1.\n";
+  test << "Li\t1.\t1.\t1.\t1.\t1.\t1.\n";
+  test << "Be\t1.\t1.\t1.\t1.\t1.\t1.\n";
+  test << "B\t1.\t1.\t1.\t1.\t1.\t1.\n";
+  test << "C\t1.2\t1.\t1.\t1.\t1.\t1.5\n";
   test.close();
   BG = new BondGraph(true);
+  CPPUNIT_ASSERT(BG != NULL && "could not create BondGraph");
 
   CPPUNIT_ASSERT_EQUAL( true , BG->LoadBondLengthTable(*filename) );
   CPPUNIT_ASSERT_EQUAL( 1., BG->GetBondLength(0,0) );
-  CPPUNIT_ASSERT_EQUAL( 1.2, BG->GetBondLength(0,1) );
-  CPPUNIT_ASSERT_EQUAL( 1.5, BG->GetBondLength(1,1) );
+  CPPUNIT_ASSERT_EQUAL( 1.2, BG->GetBondLength(0,5) );
+  CPPUNIT_ASSERT_EQUAL( 1.5, BG->GetBondLength(5,5) );
 
   BG->ConstructBondGraph(TestMolecule);
Index: molecuilder/src/unittests/analysisbondsunittest.hpp
===================================================================
--- molecuilder/src/unittests/analysisbondsunittest.hpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/analysisbondsunittest.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -34,7 +34,6 @@
 
       molecule *TestMolecule;
-      element *hydrogen;
-      element *carbon;
-      periodentafel *tafel;
+      const element *hydrogen;
+      const element *carbon;
 
       BondGraph *BG;
Index: molecuilder/src/unittests/bondgraphunittest.cpp
===================================================================
--- molecuilder/src/unittests/bondgraphunittest.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/bondgraphunittest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -15,4 +15,6 @@
 #include <stdio.h>
 #include <cstring>
+
+#include "Helpers/Assert.hpp"
 
 #include "World.hpp"
@@ -41,32 +43,15 @@
   atom *Walker = NULL;
 
-  // init private all pointers to zero
-  TestMolecule = NULL;
-  hydrogen = NULL;
-  tafel = NULL;
-
   // construct element
-  hydrogen = new element;
-  hydrogen->Z = 1;
-  hydrogen->CovalentRadius = 0.23;
-  hydrogen->VanDerWaalsRadius = 1.09;
-  strcpy(hydrogen->name, "hydrogen");
-  strcpy(hydrogen->symbol, "H");
-  carbon = new element;
-  carbon->Z = 2;
-  carbon->CovalentRadius = 0.68;
-  carbon->VanDerWaalsRadius = 1.7;
-  strcpy(carbon->name, "carbon");
-  strcpy(carbon->symbol, "C");
-
-
-  // construct periodentafel
-  tafel = World::getInstance().getPeriode();
-  tafel->AddElement(hydrogen);
-  tafel->AddElement(carbon);
+  hydrogen = World::getInstance().getPeriode()->FindElement(1);
+  carbon = World::getInstance().getPeriode()->FindElement(6);
+  CPPUNIT_ASSERT(hydrogen != NULL && "could not find element hydrogen");
+  CPPUNIT_ASSERT(carbon != NULL && "could not find element carbon");
 
   // construct molecule (tetraeder of hydrogens)
   TestMolecule = World::getInstance().createMolecule();
+  CPPUNIT_ASSERT(TestMolecule != NULL && "could not create molecule");
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = carbon;
   *Walker->node = Vector(1., 0., 1. );
@@ -74,4 +59,5 @@
 
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = carbon;
   *Walker->node = Vector(0., 1., 1. );
@@ -79,4 +65,5 @@
 
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = carbon;
   *Walker->node = Vector(1., 1., 0. );
@@ -84,4 +71,5 @@
 
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = carbon;
   *Walker->node = Vector(0., 0., 0. );
@@ -93,11 +81,18 @@
   // create a small file with table
   dummyname = new string("dummy.dat");
+  CPPUNIT_ASSERT(dummyname != NULL && "could not create string");
   filename = new string("test.dat");
+  CPPUNIT_ASSERT(filename != NULL && "could not create string");
   ofstream test(filename->c_str());
-  test << ".\tH\tC\n";
-  test << "H\t1.\t1.2\n";
-  test << "C\t1.2\t1.5\n";
+  test << ".\tH\tHe\tLi\tBe\tB\tC\n";
+  test << "H\t1.\t1.\t1.\t1.\t1.\t1.2\n";
+  test << "He\t1.\t1.\t1.\t1.\t1.\t1.\n";
+  test << "Li\t1.\t1.\t1.\t1.\t1.\t1.\n";
+  test << "Be\t1.\t1.\t1.\t1.\t1.\t1.\n";
+  test << "B\t1.\t1.\t1.\t1.\t1.\t1.\n";
+  test << "C\t1.2\t1.\t1.\t1.\t1.\t1.5\n";
   test.close();
   BG = new BondGraph(true);
+  CPPUNIT_ASSERT(BG != NULL && "could not create BondGraph");
 };
 
@@ -126,6 +121,6 @@
   CPPUNIT_ASSERT_EQUAL( true , BG->LoadBondLengthTable(*filename) );
   CPPUNIT_ASSERT_EQUAL( 1., BG->GetBondLength(0,0) );
-  CPPUNIT_ASSERT_EQUAL( 1.2, BG->GetBondLength(0,1) );
-  CPPUNIT_ASSERT_EQUAL( 1.5, BG->GetBondLength(1,1) );
+  CPPUNIT_ASSERT_EQUAL( 1.2, BG->GetBondLength(0,5) );
+  CPPUNIT_ASSERT_EQUAL( 1.5, BG->GetBondLength(5,5) );
 };
 
Index: molecuilder/src/unittests/bondgraphunittest.hpp
===================================================================
--- molecuilder/src/unittests/bondgraphunittest.hpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/bondgraphunittest.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -37,7 +37,6 @@
 
       molecule *TestMolecule;
-      element *hydrogen;
-      element *carbon;
-      periodentafel *tafel;
+      const element *hydrogen;
+      const element *carbon;
 
       BondGraph *BG;
Index: molecuilder/src/unittests/listofbondsunittest.cpp
===================================================================
--- molecuilder/src/unittests/listofbondsunittest.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/listofbondsunittest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -38,35 +38,28 @@
   atom *Walker = NULL;
 
-  // init private all pointers to zero
-  TestMolecule = NULL;
-  hydrogen = NULL;
-  tafel = NULL;
-
   // construct element
-  hydrogen = new element;
-  hydrogen->Z = 1;
-  strcpy(hydrogen->name, "hydrogen");
-  strcpy(hydrogen->symbol, "H");
-
-
-  // construct periodentafel
-  tafel = World::getInstance().getPeriode();
-  tafel->AddElement(hydrogen);
+  hydrogen = World::getInstance().getPeriode()->FindElement(1);
+  CPPUNIT_ASSERT(hydrogen != NULL && "could not find element hydrogen");
 
   // construct molecule (tetraeder of hydrogens)
   TestMolecule = World::getInstance().createMolecule();
-  Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(TestMolecule != NULL && "could not create molecule");
+  Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = hydrogen;
   *Walker->node = Vector(1., 0., 1. );
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = hydrogen;
   *Walker->node = Vector(0., 1., 1. );
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = hydrogen;
   *Walker->node = Vector(1., 1., 0. );
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
   Walker->type = hydrogen;
   *Walker->node = Vector(0., 0., 0. );
@@ -75,5 +68,4 @@
   // check that TestMolecule was correctly constructed
   CPPUNIT_ASSERT_EQUAL( TestMolecule->AtomCount, 4 );
-
 };
 
Index: molecuilder/src/unittests/listofbondsunittest.hpp
===================================================================
--- molecuilder/src/unittests/listofbondsunittest.hpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/listofbondsunittest.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -41,6 +41,5 @@
 
       molecule *TestMolecule;
-      element *hydrogen;
-      periodentafel *tafel;
+      const element *hydrogen;
 };
 
Index: molecuilder/src/unittests/periodentafelTest.cpp
===================================================================
--- molecuilder/src/unittests/periodentafelTest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/unittests/periodentafelTest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,78 @@
+/*
+ * periodentafelTest.cpp
+ *
+ *  Created on: May 18, 2010
+ *      Author: heber
+ */
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "Helpers/Assert.hpp"
+
+#include "World.hpp"
+#include "periodentafelTest.hpp"
+#include "element.hpp"
+#include "elements_db.hpp"
+#include "periodentafel.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( periodentafelTest );
+
+
+void periodentafelTest::setUp()
+{
+  // make sure world is present
+  tafel = World::getInstance().getPeriode();
+  CPPUNIT_ASSERT(tafel != NULL && "could not obtain periodentafel");
+};
+
+
+void periodentafelTest::tearDown()
+{
+  World::purgeInstance();
+};
+
+/** UnitTest for AddRemoveTest().
+ */
+void periodentafelTest::AddRemoveTest()
+{
+  // copy the element
+  const element * ElementPtr = tafel->FindElement(3);
+  CPPUNIT_ASSERT( ElementPtr != NULL && "could not find element lithium");
+  element *Elemental = new element(*ElementPtr);
+  // remove element
+  tafel->RemoveElement((element * const)ElementPtr);
+  ElementPtr = tafel->FindElement(3);
+  CPPUNIT_ASSERT_EQUAL( (const element *)NULL, ElementPtr );
+  // add element again
+  tafel->AddElement((element * const)Elemental);
+  ElementPtr = tafel->FindElement(3);
+  CPPUNIT_ASSERT( ElementPtr != NULL && "could not find re-added element lithium");
+};
+
+/** UnitTest for LoadStoreTest().
+ * TODO: periodentafelTest::LoadStoreTest() not implemented yet
+ */
+void periodentafelTest::LoadStoreTest()
+{
+  // reload all databases
+  CPPUNIT_ASSERT(tafel->LoadElementsDatabase(new stringstream(elementsDB,ios_base::in)) && "General element initialization failed");
+  CPPUNIT_ASSERT(tafel->LoadValenceDatabase(new stringstream(valenceDB,ios_base::in)) && "Valence entry of element initialization failed");
+  CPPUNIT_ASSERT(tafel->LoadOrbitalsDatabase(new stringstream(orbitalsDB,ios_base::in)) && "Orbitals entry of element initialization failed");
+  CPPUNIT_ASSERT(tafel->LoadHBondAngleDatabase(new stringstream(HbondangleDB,ios_base::in)) && "HBond angle entry of element initialization failed");
+  CPPUNIT_ASSERT(tafel->LoadHBondLengthsDatabase(new stringstream(HbonddistanceDB,ios_base::in)) && "HBond distance entry of element initialization failed");
+  // check presence of elements
+  atomicNumber_t Z = 1;
+  for(periodentafel::const_iterator ElementRunner = tafel->begin(); ElementRunner != tafel->end(); ++ElementRunner)
+    CPPUNIT_ASSERT( (ElementRunner->second->getNumber() == Z++) && "element is missing in sequence");
+};
Index: molecuilder/src/unittests/periodentafelTest.hpp
===================================================================
--- molecuilder/src/unittests/periodentafelTest.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/unittests/periodentafelTest.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,39 @@
+/*
+ * periodentafelTest.hpp
+ *
+ *  Created on: May 18, 2010
+ *      Author: heber
+ */
+
+#ifndef ANALYSISBONDSUNITTEST_HPP_
+#define ANALYSISBONDSUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class element;
+class periodentafel;
+
+/********************************************** Test classes **************************************/
+
+class periodentafelTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( periodentafelTest) ;
+    CPPUNIT_TEST ( AddRemoveTest );
+    CPPUNIT_TEST ( LoadStoreTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void AddRemoveTest();
+      void LoadStoreTest();
+
+private:
+
+      element *hydrogen;
+      element *carbon;
+      periodentafel *tafel;
+
+};
+
+#endif /* ANALYSISBONDSUNITTEST_HPP_ */
Index: molecuilder/src/unittests/tesselation_boundarytriangleunittest.cpp
===================================================================
--- molecuilder/src/unittests/tesselation_boundarytriangleunittest.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/tesselation_boundarytriangleunittest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -37,19 +37,16 @@
   tesselpoints[0] = new TesselPoint;
   tesselpoints[0]->node = new Vector(0., 0., 0.);
-  tesselpoints[0]->Name = Malloc<char>(3, "TesselationBoundaryTriangleTest::setUp - *Name");
-  strcpy(tesselpoints[0]->Name, "1");
+  tesselpoints[0]->setName("1");
   tesselpoints[0]->nr = 1;
   points[0] = new BoundaryPointSet(tesselpoints[0]);
   tesselpoints[1] = new TesselPoint;
   tesselpoints[1]->node = new Vector(0., 1., 0.);
-  tesselpoints[1]->Name = Malloc<char>(3, "TesselationBoundaryTriangleTest::setUp - *Name");
-  strcpy(tesselpoints[1]->Name, "2");
+  tesselpoints[1]->setName("2");
   tesselpoints[1]->nr = 2;
   points[1] = new BoundaryPointSet(tesselpoints[1]);
   tesselpoints[2] = new TesselPoint;
-  tesselpoints[2] ->node = new Vector(1., 0., 0.);
-  tesselpoints[2] ->Name = Malloc<char>(3, "TesselationBoundaryTriangleTest::setUp - *Name");
-  strcpy(tesselpoints[2] ->Name, "3");
-  tesselpoints[2] ->nr = 3;
+  tesselpoints[2]->node = new Vector(1., 0., 0.);
+  tesselpoints[2]->setName("3");
+  tesselpoints[2]->nr = 3;
   points[2] = new BoundaryPointSet(tesselpoints[2] );
 
Index: molecuilder/src/unittests/tesselation_insideoutsideunittest.cpp
===================================================================
--- molecuilder/src/unittests/tesselation_insideoutsideunittest.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/tesselation_insideoutsideunittest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -38,48 +38,40 @@
   Walker = new TesselPoint;
   Walker->node = new Vector(0., 0., 0.);
-  Walker->Name = Malloc<char>(3, "TesselationInOutsideTest::setUp - *Name");
-  strcpy(Walker->Name, "1");
+  Walker->setName("1");
   Walker->nr = 1;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
   Walker->node = new Vector(0., 1., 0.);
-  Walker->Name = Malloc<char>(3, "TesselationInOutsideTest::setUp - *Name");
-  strcpy(Walker->Name, "2");
+  Walker->setName("2");
   Walker->nr = 2;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
   Walker->node = new Vector(1., 0., 0.);
-  Walker->Name = Malloc<char>(3, "TesselationInOutsideTest::setUp - *Name");
-  strcpy(Walker->Name, "3");
+  Walker->setName("3");
   Walker->nr = 3;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
   Walker->node = new Vector(1., 1., 0.);
-  Walker->Name = Malloc<char>(3, "TesselationInOutsideTest::setUp - *Name");
-  strcpy(Walker->Name, "4");
+  Walker->setName("4");
   Walker->nr = 4;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
   Walker->node = new Vector(0., 0., 1.);
-  Walker->Name = Malloc<char>(3, "TesselationInOutsideTest::setUp - *Name");
-  strcpy(Walker->Name, "5");
+  Walker->setName("5");
   Walker->nr = 5;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
   Walker->node = new Vector(0., 1., 1.);
-  Walker->Name = Malloc<char>(3, "TesselationInOutsideTest::setUp - *Name");
-  strcpy(Walker->Name, "6");
+  Walker->setName("6");
   Walker->nr = 6;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
   Walker->node = new Vector(1., 0., 1.);
-  Walker->Name = Malloc<char>(3, "TesselationInOutsideTest::setUp - *Name");
-  strcpy(Walker->Name, "7");
+  Walker->setName("7");
   Walker->nr = 7;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
   Walker->node = new Vector(1., 1., 1.);
-  Walker->Name = Malloc<char>(3, "TesselationInOutsideTest::setUp - *Name");
-  strcpy(Walker->Name, "8");
+  Walker->setName("8");
   Walker->nr = 8;
   Corners.push_back(Walker);
Index: molecuilder/src/unittests/tesselationunittest.cpp
===================================================================
--- molecuilder/src/unittests/tesselationunittest.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/tesselationunittest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -37,24 +37,20 @@
   Walker = new TesselPoint;
   Walker->node = new Vector(1., 0., -1.);
-  Walker->Name = Malloc<char>(3, "TesselationTest::setUp");
-  strcpy(Walker->Name, "1");
+  Walker->setName("1");
   Walker->nr = 1;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
   Walker->node = new Vector(-1., 1., -1.);
-  Walker->Name = Malloc<char>(3, "TesselationTest::setUp");
-  strcpy(Walker->Name, "2");
+  Walker->setName("2");
   Walker->nr = 2;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
   Walker->node = new Vector(-1., -1., -1.);
-  Walker->Name = Malloc<char>(3, "TesselationTest::setUp");
-  strcpy(Walker->Name, "3");
+  Walker->setName("3");
   Walker->nr = 3;
   Corners.push_back(Walker);
   Walker = new TesselPoint;
   Walker->node = new Vector(-1., 0., 1.);
-  Walker->Name = Malloc<char>(3, "TesselationTest::setUp");
-  strcpy(Walker->Name, "4");
+  Walker->setName("4");
   Walker->nr = 4;
   Corners.push_back(Walker);
Index: molecuilder/tests/Tesselations/defs.in
===================================================================
--- molecuilder/tests/Tesselations/defs.in	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/tests/Tesselations/defs.in	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -62,5 +62,7 @@
 	#cat stderr
 	#cat stdout
-	diff ${FILENAME}.dat ../@srcdir@/$mol/$2/${FILENAME}-$mol.dat 2>diffstderr >diffstdout || exitcode=$?
+        grep -E "^[0-9]* [0-9]* [0-9]*$" ../../../../../molecuilder/tests/Tesselations/$mol/$2/${FILENAME}-$mol.dat | sort -n >reference-triangles.dat
+        grep -E "^[0-9]* [0-9]* [0-9]*$" ${FILENAME}.dat | sort -n >new-triangles.dat
+        diff reference-triangles.dat new-triangles.dat 2>diffstderr >diffstdout || exitcode=$?
 	#echo "Diff done with exitcode $exitcode."
 	#cat diffstderr
Index: molecuilder/tests/regression/Simple_configuration/2/post/test.conf.in
===================================================================
--- molecuilder/tests/regression/Simple_configuration/2/post/test.conf.in	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/tests/regression/Simple_configuration/2/post/test.conf.in	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,24 @@
+% Created by MoleCuilder
+mpqc: (
+	savestate = no
+	do_gradient = yes
+	mole<MBPT2>: (
+		maxiter = 200
+		basis = $:basis
+		molecule = $:molecule
+		reference<CLHF>: (
+			basis = $:basis
+			molecule = $:molecule
+		)
+	)
+)
+molecule<Molecule>: (
+	unit = angstrom
+	{ atoms geometry } = {
+		H [ 0	0	0 ]
+	}
+)
+basis<GaussianBasisSet>: (
+	name = "3-21G"
+	molecule = $:molecule
+)
Index: molecuilder/tests/regression/Simple_configuration/3/post/test.conf.in
===================================================================
--- molecuilder/tests/regression/Simple_configuration/3/post/test.conf.in	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/tests/regression/Simple_configuration/3/post/test.conf.in	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,24 @@
+% Created by MoleCuilder
+mpqc: (
+	savestate = no
+	do_gradient = yes
+	mole<MBPT2>: (
+		maxiter = 200
+		basis = $:basis
+		molecule = $:molecule
+		reference<CLHF>: (
+			basis = $:basis
+			molecule = $:molecule
+		)
+	)
+)
+molecule<Molecule>: (
+	unit = angstrom
+	{ atoms geometry } = {
+		H [ 0	0	0 ]
+	}
+)
+basis<GaussianBasisSet>: (
+	name = "3-21G"
+	molecule = $:molecule
+)
